﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_WeeklyReport.js", RegisterProjectProgressOverride); // CSR-override for MDS enabled site
RegisterProjectProgressOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)
  


function RegisterProjectProgressOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/projectprogress.css' rel='stylesheet' type='text/css'/>";
	overrideCtx.Templates.Header = registerCssTag + "<ul class='projectProgress'>";
	overrideCtx.Templates.Footer = "</ul>";

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//   	 Register the template overrides.

	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);

};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access announcement data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
   	var currItem = ctx.CurrentItem;
   	var ragStatusImg = "";
   	var pmPicture = "";
   	
   	switch(ctx.CurrentItem.RAGStatus)
	{
	 case "3 - Green":
	  ragStatusImg = "<img src='/_layouts/15/images/kpinormallarge-0.gif' />";
	   break;
	 case "2 - Amber":
	  ragStatusImg = "<img src='/_layouts/15/images/kpinormallarge-1.gif' />";
	   break;
	 default:
	  ragStatusImg = "<img src='/_layouts/15/images/kpinormallarge-2.gif' />";
	}
	
	if (ctx.CurrentItem.ProjectManager[0].picture.length != 0)
	{
		pmPicture = ctx.CurrentItem.ProjectManager[0].picture;
	}
	else
	{
		pmPicture = "/_layouts/15/images/no_pic.gif";
	}
   
    var ret = "<li id='projectProgressItem" + ctx.CurrentItemIdx + "' class='projectProgressWrapper'>";
    ret += "<span class='projectProgressImageWrapper'><img class='projectProgressImg' src='" + pmPicture + "'>";
    ret += ctx.CurrentItem.ProjectManager[0].title + "</span>"
    ret += "<span class='projectProgressMiddleWrapper'><span class='projectProgressTitle'>" + ctx.CurrentItem.Title + " - </span>";
    ret += "<span class='projectProgressDescription'>" + ctx.CurrentItem.ProjectDescription + "</span><br/><br/>";
    ret += "<span class='projectProgressBarWrapper'>0%";
    ret += "<span class='projectProgressBar' style='width:" + ctx.CurrentItem.PercentComplete + ";'>&nbsp;</span>"; 
    ret += ctx.CurrentItem.PercentComplete + "</span></span>"
    ret += "<span class='projectProgressRagWrapper'>" + ragStatusImg + "</span>";
    ret += "</li>";
	return ret;
}
