﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_MyTeam.js", RegisterMyTeamOverride); // CSR-override for MDS enabled site
RegisterMyTeamOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)
  


function RegisterMyTeamOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/myteam.css' rel='stylesheet' type='text/css'/>";
	overrideCtx.Templates.Header = registerCssTag + "<ul class='myTeam'>";
	overrideCtx.Templates.Footer = "</ul>";

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//   	 Register the template overrides.

	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);

};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access list item data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
   	var currItem = ctx.CurrentItem;
   	var personID = currItem.Person[0].id;
   
    var ret = "<li id='myTeamItem" + ctx.CurrentItemIdx + "' class='myTeamItemWrapper myTeamItemSeniority" + currItem.Seniority + "'><div class='myTeamItemTitle'>";
	ret += currItem.Title + "</div>";
    ret += "<div class='myTeamItemName'>" + currItem.Person[0].title + "</div>";
    if (currItem.Person[0].picture)
    {
    	var pictureUrl = currItem.Person[0].picture;
    	//If this is the first object, we need the LThumb...
    	if (ctx.CurrentItemIdx === 0)
    	{
    		pictureUrl = pictureUrl.replace("MThumb","LThumb");
    	}
    	ret+= "<img class='myTeamPicture' id='myTeamPicture" + ctx.CurrentItemIdx + "' src='" + pictureUrl + "'/>";
    }
    
    if (currItem.Seniority <= 2)
    {
   		ret+= "<div class='myTeamShortBio' id='myTeamShortBio" + ctx.CurrentItemIdx + "'>" + currItem.ShortBio + "</div>";
	}
	else
	{
		var myTeamHoverPanelID = "myTeamInfoHoverPanel" + ctx.CurrentItemIdx;
		ret+= "<div class='myTeamInfoHoverPanel' id='" + myTeamHoverPanelID + "'>" + currItem.ShortBio + "</div>";
		ret+= "<div class='myTeamInfoIconWrapper' style='right:29px;bottom:2px;' OnMouseOver=myTeamHoverToggle('" + myTeamHoverPanelID  + "') OnMouseOut=myTeamHoverToggle('" + myTeamHoverPanelID  + "')>" +
			 "<span class='myTeamInfoIcon'><img class='myTeamInfoIconHoverInfo'src='/_layouts/15/images/EMPTY.GIF'/></span></div>";
	}
	ret+= "<div class='myTeamInfoIconWrapper' style='right:2px;bottom:2px;'><a title='View profile' href='/_layouts/15/userdisp.aspx?ID=" + personID + "'><span class='myTeamInfoIcon'><img class='myTeamInfoIconProfile'src='/_layouts/15/images/EMPTY.GIF'/></span></a></div>";
    
	ret += "</li>";
	return ret;
}

function myTeamHoverToggle(hoverPanelID)
{
	$('#' + hoverPanelID).toggle();
}
