﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_ShopListBroken.js", RegisterShopListBrokenOverride); // CSR-override for MDS enabled site
RegisterShopListBrokenOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)
  
function RegisterShopListBrokenOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/shoplist.css' rel='stylesheet' type='text/css'/>";
	overrideCtx.Templates.Header = registerCssTag + "<ul class='ShopDescriptionList'>";
	overrideCtx.Templates.Footer = "</ul>";

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//  Register the template overrides with SharePoint
	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);
};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access list item data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
    var returnHtml = "<li id='myTeamItem" + ctx.CurrentItemIdx + "'><div class='branchnumber'>" 
    	+ ctx.CurrentItem.Title + "</div>"
    	+ "<div class='branchaddress'>" + ctx.CurrentItem.Address + "</div>"
    	+ "<div class='imageWrapper'><img class='branchImage' src='" 
    	+ ctx.CurrentItem.BranchPicture + "' alt='" + ctx.CurrentItem.Title + "' /></div>"
    	+ "</li>";
	return returnHtml;
}

