﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_WeeklyReport.js", RegisterWeeklyReportOverride); // CSR-override for MDS enabled site
RegisterWeeklyReportOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)
  


function RegisterWeeklyReportOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/weeklyReport.css' rel='stylesheet' type='text/css'/>";
	overrideCtx.Templates.Header = registerCssTag + "<ul class='weeklyReport'>";
	overrideCtx.Templates.Footer = "</ul>";

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//   	 Register the template overrides.

	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);

};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access announcement data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
   	var currItem = ctx.CurrentItem
   
    var ret = "<li id='weeklyReportItem" + ctx.CurrentItemIdx + "' class='weeklyReportWrapper'>";
	ret += "<div class='weeklyReportTitleWrapper'><span class='weeklyReportTitleLeft weeklyReportTitleLeft" + currItem.HeaderBarColour + "'>&nbsp;</span><span class='weeklyReportTitle weeklyReportTitle" +
	 currItem.HeaderBarColour + "'>" + currItem.Title;
	ret += "</span><div class='weeklyReportPicture'>" + currItem.DivisionHeadPicture + "</div></div>";
	ret += "<div class='weeklyReportContent'>" + currItem.ReportContent + "</div>";
   	ret += "</li>";
	return ret;
}
